#ENSIGHT_USER_DEFINED_BEGIN
#FACTORY=ctor
#ENSIGHT_USER_DEFINED_END
#
# *************************************************************
#  Copyright 1995-2010 Computational Engineering International, Inc.
#  All Rights Reserved.
#
#  Restricted Rights Legend
#
#  Use, duplication, or disclosure of this
#  software and its documentation by the
#  Government is subject to restrictions as
#  set forth in subdivision [(b)(3)(ii)] of
#  the Rights in Technical Data and Computer
#  Software clause at 52.227-7013.
# *************************************************************
#
# Import the parent class for all user-defined menus and the ensight module
#
import ensight
from ensight.core.menu_extension import menu_extension
import os,os.path
#
# Define a menu class, a subclass of the menu_extension class
#
class another_simple_menu(menu_extension):
#
# Construct the menu with reasonable defaults
#
    def __init__(self,name,parent,text="",tooltip="",desc="",icon=None):
        menu_extension.__init__(self,name,__file__,1.0)
        if (parent):
            parent.addChild(self)
        if (icon):
            self.setIcon(icon)
        self.setText(text)
        self.setDesc(text)
        self.setTooltip(text)
#
# Method that is called when the menu is selected
#
    def run(self):
        print "Menu:",self.getText()," selected"

#
# Allow multiple extensions to fall under the same parent menu
# If my parent menu exists, use it, otherwise create it
#
def find_folder_ext(parent,objs):
    rjf = ensight.core.core_extension.find_extension("menu","rjf_parent_menu_ext")
    if (not rjf):
        rjf = menu_extension("rjf_parent_menu_ext",None)
        rjf.setText("RJFs Menus")
        rjf.setTooltip("Randy's menu extensions")
        rjf.setDesc("Randy's menu extensions")
        dir = os.path.dirname(__file__)
        rjf.setIcon(os.path.join(dir,"goat.png"))
        if (parent):
           parent.addChild(rjf)
        objs.append(rjf)
    return rjf
#
def ctor(parent):
    objs = []
    p = find_folder_ext(parent,objs)
    # create our ext
    tmp = another_simple_menu("rjf_menu2",p,"Another menu...")
    objs.append(tmp)
    return objs

