#ENSIGHT_USER_DEFINED_BEGIN
#FACTORY=ctor
#ENSIGHT_USER_DEFINED_END
#
# *************************************************************
#  Copyright 1995-2010 Computational Engineering International, Inc.
#  All Rights Reserved.
#
#  Restricted Rights Legend
#
#  Use, duplication, or disclosure of this
#  software and its documentation by the
#  Government is subject to restrictions as
#  set forth in subdivision [(b)(3)(ii)] of
#  the Rights in Technical Data and Computer
#  Software clause at 52.227-7013.
# *************************************************************
#
from cei.qtgenericdlg import *
from ensight.core.tool_extension import *  
#
# Extension class
#
class multi_tool(tool_extension):
    def __init__(self,name,title,desc,icon):
        tool_extension.__init__(self,name,__file__,1.0)
        dir = os.path.dirname(__file__)
        self.setIcon(os.path.join(dir,icon))
        self.setText(title)
        self.setDesc(desc)
        self.setTooltip(desc)
        self.setHelpURL("https://sites.google.com/a/ensight.com/ensight-python-api/object-api/framework-classes")
#
# Execute the tool from the gui
#
    def run(self):
        items = []
        items.append(['text',ITEM_TEXT,self.getDesc(),""])
        d = CeiQtGenericDialog(items,title=self.getText(),help=self)
        if (d.doit()):
            print "Ok"
        else:
            print "Cancel"
#
# Play back the tool from command language
#
    def cmdExec(self,str):
        print "cmdExec(",str,")"  
#
# Construct the extension instance
#
def find_folder_ext(parent,objs):
    rjf = ensight.core.core_extension.find_extension("tool","rjf_parent_ext")
    if (not rjf):
        rjf = tool_extension("rjf_parent_ext",None)
        rjf.setText("RJFs Tools")
        rjf.setTooltip("Randy's tool extensions")
        rjf.setDesc("Randy's tool extensions")
        dir = os.path.dirname(__file__)
        rjf.setIcon(os.path.join(dir,"goat.png"))
        if (parent):
           parent.addChild(rjf)
        objs.append(rjf)
    return rjf
#
#
def ctor(parent):
    objs = []
    p = find_folder_ext(parent,objs)
    bars = tool_extension("rjf_subgreoup_parent_ext",None)
    bars.setText("RJFs Subgroup Tools")
    bars.setTooltip("Randy's subgroup tool extensions")
    bars.setDesc("Randy's subgroup tool extensions")
    dir = os.path.dirname(__file__)
    bars.setIcon(os.path.join(dir,"ext_group.png"))
    # create our extensions
    tmp1 = multi_tool("my_disc_tool","MiniDisc tool","An example 'minidisc' tool","disc_icon.png")
    tmp2 = multi_tool("my_graph_tool","Graph tool","An example 'graph' tool","graph_icon.png")
    # return a complete set of instances
    objs.append(tmp1)
    objs.append(tmp2)
    objs.append(bars)
    # make the heirarchy
    p.addChild(bars)
    bars.addChild(tmp1)
    bars.addChild(tmp2)
    return objs
