#ENSIGHT_USER_DEFINED_BEGIN
#FACTORY=ctor
#ENSIGHT_USER_DEFINED_END
#
# *************************************************************
#  Copyright 1995-2010 Computational Engineering International, Inc.
#  All Rights Reserved.
#
#  Restricted Rights Legend
#
#  Use, duplication, or disclosure of this
#  software and its documentation by the
#  Government is subject to restrictions as
#  set forth in subdivision [(b)(3)(ii)] of
#  the Rights in Technical Data and Computer
#  Software clause at 52.227-7013.
# *************************************************************
#
from cei.qtgenericdlg import *
from ensight.core.tool_extension import *
import math,ensight

def ask_user_for_input(tool):
    dim = ensight.query(ensight.DATASET)[4]
    d =     (dim[0][0] - dim[1][0])*(dim[0][0] - dim[1][0])
    d = d + (dim[0][1] - dim[1][1])*(dim[0][1] - dim[1][1])
    d = d + (dim[0][2] - dim[1][2])*(dim[0][2] - dim[1][2])
    p = []
    p.append((dim[0][0] + dim[1][0])*0.5)
    p.append((dim[0][1] + dim[1][1])*0.5)
    p.append((dim[0][2] + dim[1][2])*0.5)
    dist = math.sqrt(d)
    items = []
    items.append(['text',ITEM_TEXT,"Enter parameters",""])
    items.append(['px',ITEM_FLT,"Centroid X","X center of sphere",p[0],-dist,dist])
    items.append(['py',ITEM_FLT,"Centroid Y","Y center of sphere",p[1],-dist,dist])
    items.append(['pz',ITEM_FLT,"Centroid Z","Z center of sphere",p[2],-dist,dist])
    d = CeiQtGenericDialog(items,title="example demo",help=tool)
    if (d.doit()):
        params = {}
        p = []
        p.append(d.getValue('px'))
        p.append(d.getValue('py'))
        p.append(d.getValue('pz'))
        params['point'] = p
        return params
    return None
#
# Tool action code
#
def run_tool(params,obj):
    print "Running with parameters:",params
    # record the operation in command language
    obj.cmdRecord("point '[%.5f,%.5f,%.5f]'" % tuple(p))
    obj.cmdRecord("compute")    
#
# Extension class
#
class rjf_demo_tool(tool_extension):
    def __init__(self):
        tool_extension.__init__(self,"rjf_simple_demo_tool",__file__,1.0)
        self.setText("RJFs Demo Tool")
        self.setDesc("Prompt the user for a centroid")
        self.setTooltip("Simple demo tool")
        self.setIcon(":/ensight/wiz")
        self.setHelpURL("https://sites.google.com/a/ensight.com/ensight-python-api/object-api/framework-classes")
        self.cmdClear()
#
# Execute the tool from the gui
#
    def run(self):
        params = ask_user_for_input(self)
        if (params == None):
            return
        run_tool(params,self)
#
# Play back the tool from command language
#
    def cmdExec(self,str):
        p = str.split("'")
        try:
            t = p[0].strip()
            if (t == 'compute'):
                run_tool(self._params,self)
                self.cmdClear()
            else:
                exec("d = "+p[1])
                self._params[t] = d
        except Exception, e:
            print "Error handling the command:",str,e   
#
    def cmdClear(self):
        params = {}
        params['point'] = [0.,0.,0.]
        self._params = params
#
# Construct the extension instance
#
# Allow multiple extensions to fall under the same group tool
# If my parent group exists, use it, otherwise create it
#
def find_folder_ext(parent,objs):
    rjf = ensight.core.core_extension.find_extension("tool","rjf_parent_ext")
    if (not rjf):
        rjf = tool_extension("rjf_parent_ext",None)
        rjf.setText("RJFs Tools")
        rjf.setTooltip("Randy's tool extensions")
        rjf.setDesc("Randy's tool extensions")
        dir = os.path.dirname(__file__)
        rjf.setIcon(os.path.join(dir,"goat.png"))
        if (parent):
           parent.addChild(rjf)
        objs.append(rjf)
    return rjf
#
def ctor(parent):
    objs = []
    p = find_folder_ext(parent,objs)
    # create our ext
    tmp = rjf_demo_tool()
    objs.append(tmp)
    p.addChild(tmp)
    return objs

